               JOB  PRIME
     * GENERATE PRIME NUMBERS. DEMO FOR COMPUTER HISTORY MUSEUM
     * KEN SHIRRIFF  HTTP://RIGHTO.COM
               HEAD
     * IMPORTANT NOTE ON THE BITMASK: IT HOLDS ODD NUMBERS,STARTING WITH 3.
     * SO N IS IN ADDRESS BITS0+(N-3)/2
     REV       DCW  @REVISION 3 COMPILED ON MARCH 3, 2015@
     TO        DCW  #5         * TEMPORARY

     MAX       DCW  @25000@    * MAXIMUM NUMBER TO PRINT
     MAXADR    DCW  @12500@    * MAX/2
     SQRT      DCW  @00158@    * SQRT(MAX)  

     ADR       DCW  #5
     STEP      DCW  #3        * ADDRESS STEP WHEN MOVING THROUGH BITMASK
     LINENO    DCW  #2        * LINE NUMBER ON PAGE
     PAGENO    DCW  #1

     PPTR      DCW  #5   * PRIME/2-1.5,AS A 3-CHAR ADDRESS
     PPTR5     DCW  #5                 * PPTR AS 5-DIGIT VALUE,NOT ADDRESS
     *  BITS[(N-1)/2] = 1 IF N HAS NOT BEEN ELIMINATED
     ENDADR    DCW  @000@
     
               DCW  @A LIST OF PRIME NUMBERS UNDER 25,000 GE@
               DC   @NERATED BY THE IBM 1401 AT THE COMPUTER@
     LINE1     DC   @ HISTORY MUSEUM IN MOUNTAIN VIEW,CA@

               DCW  @THIS PRINTOUT WAS GENERATED ON AN IBM 1401 @
               DC   @COMPUTER AT THE COMPUTER HISTORY MUSEUM, @
     CREDIT    DC   @ MOUNTAIN VIEW, CALIFORNIA@



     PROD      DCW  #11        * SIZEOF(COUNT)*2+1
     POS       DCW  #3      * POSITION ON LINE. 
     
     * CONVERSION CONSTANTS
     HZONE     DCW  @9ZRI9ZRI9ZRI9ZRI@
     LZONE     DCW  @9999ZZZZRRRRIIII@

     BITS0     DCW  BITS-12499
     BITS      DS   12500      * LENGTH IS MAX/2.  
               ORG  15000
     START     CS   299
               MCW  REV,180                * LEAVE ID BEHIND
               MCW  @00000@,PPTR
               MCW  @00000@,PPTR5
               MCW  @007@,POS              * NEEDS TO MATCH CODE IN WRITE
               MCW  @1@,PAGENO
               B    HEADER                  * PRINT HEADER
               MCW  @00002@,TO
               B    WRITE                   * PRINT 2 AS A SPECIAL CASE

     
     *  INITIALIZE END ADDRESS
               MCW  MAXADR,ADR
               B    CONV2
               MCW  ADR,ENDADR
     

     OUTER     MCW  PPTR,X2          * SEARCH FOR NEXT CLEAR BIT  
     SCAN      C    X2,ENDADR
               BE   DONE
               C    BITS0&X2,@1@      * FOUND A PRIME (BIT IS NOT 1)?
               BU   FOUND
               MA   @001@,X2
               A    +1,PPTR5          
               B    SCAN
     DONE      NOP
               EXIT

     FOUND     MCW  X2,PPTR           * FOUND A PRIME AT INDEX X2. NEED TO CONVERT TO NUMBER,WHICH IS INCONVENIENT
               MA   @001@,PPTR        * INCREMENT THE INDEX
               MZ   @0@,PPTR5
               MCW  PPTR5,PROD-6
               A    +1,PPTR5

     * PRIME = 2*INDEX+3,I.E. 2*TO+3
               M    @2@,PROD-4
               A    @3@,PROD-4        * ADD 3
               MZ   @0@,PROD-4        * CLEAR ZONE
               MCW  PROD-4,TO
               B    WRITE              * WRITE THE PRIME
               C    SQRT,TO           * DON'T CROSS OFF ANY MULTIPLES ONCE PAST SQUARE ROOT OF MAX
               BH   OUTER
        
               MCW  TO,ADR            * CROSS OFF EVERY 2*PRIME (IGNORING EVEN),I.E. INCREMENT INDEX BY PRIME
               B    CONV2
               MCW  ADR,STEP          * STEP HOLDS THE INCREMENT FOR CROSSING-OFF  
     * COMPUTE PRIME^2,WHICH IS WHERE TO START MARKING OFF NUMBERS
               MCW  TO,PROD-6
               M    TO,PROD
               MZ   @0@,PROD
     * SUBTRACT 3 AND DIVIDE BY 2 TO CONVERT BACK TO INDEX
               MCW  PROD,TO
               S    @3@,TO
               MZ   @0@,TO
               ZA   TO,PROD-4
               D    @2@,PROD-8
               MZ   @0@,PROD-6        * PROD-6 IS NEW INDEX
               MCW  PROD-6,ADR
               B    CONV2
               MCW  ADR,X2            * X2 IS NEW INDEX AS AN ADDRESS
               MCW  PROD-6,ADR        * ADR IS NEW INDEX AS A NUMBER        
              
     * STEP THROUGH ALL THE MULTIPLES OF PRIME STARTING AT PRIME^2,SETTING THE BITS
     CLEAR     C    ADR,MAXADR        * DONE?
               BL   OUTER              * GO BACK TO OUTER LOOP
               MN   @1@,BITS0&X2
               MA   STEP,X2           * INCREMENT X2 BY STEP
               A    STEP,ADR          * INCREMENT ADR BY STEP
               B    CLEAR
     
     * END OF MAIN PROGRAM
     
     * ROUTINE TO WRITE VALUE IN "TO" TO PRINTER IN 10 COLUMNS
     WRITE     SBR  WRITEX&3
               C    @60@,LINENO       * PRINT HEADER AT LINE 60
               BU   NOHEAD
               B    HEADER

     NOHEAD    MCW  POS,X3
               LCA  @00,000@,200&X3
               MCE  TO,200&X3
               A    @8@,X3
               MZ   @0@,X3
               MCW  X3,POS
               C    @111@,POS         * 7+8*13 = 111
               BU   WRITEX
               W                       * LINE IS COMPLETE
               MCW  @007@,POS
               A    +1,LINENO
               MZ   @0@,LINENO
               CS   332
               CS
     WRITEX    B    000
     
     * ROUTINE TO PRINT THE NEXT HEADER LINE
     HEADER    SBR  HEADEX&3
               CC   1                       * EJECT PAGE

               MCW  LINE1,312
               MCW  @PAGE X OF 4@,330      * PAGE COUNT HEADER
               MCW  PAGENO,325
               W
               A    @1@,PAGENO
               MZ   @0@,PAGENO          
               CS   332                          * BLANK LINE AFTER HEADER
               CS
               W
               MCW  @03@,LINENO                 * NOW ON LINE 3
     HEADEX    B    @000@
             

     * ROUTINE TO CONVERT 5-DIGIT ADDRESS TO 3-DIGIT ADDRESS.
     * FROM VAN SNYDER.
     * FASTEST ROUTINE TO CONVERT THE FIVE-DIGIT NUMBER IN ADR TO
     * A THREE CHARACTER ADDRESS,IN PLACE.  USES X1.  WOULD BE
     * SLOWER AND 14 CHARACTERS LONGER IF IT SAVED AND RESTORED X1.
     *

     CONV2     SBR  CONV2X&3
               MCW  ADR-3,X1
               MCW  @0@
               MZ   HZONE-15&X1,ADR-2
               MZ   LZONE-15&X1,ADR
     CONV2X    B    0-0
               END  START
